Index: code/branches/core3/src/core/CommandEvaluation.cc
===================================================================
--- code/branches/core3/src/core/CommandEvaluation.cc	(revision 1727)
+++ code/branches/core3/src/core/CommandEvaluation.cc	(revision 1728)
@@ -304,5 +304,5 @@
 
             if (command->defaultValueSet(i))
-                output += "=" + command->getDefaultValue(i).toString() + "]";
+                output += "=" + command->getDefaultValue(i).getString() + "]";
             else
                 output += "}";
Index: code/branches/core3/src/core/ConfigValueContainer.cc
===================================================================
--- code/branches/core3/src/core/ConfigValueContainer.cc	(revision 1727)
+++ code/branches/core3/src/core/ConfigValueContainer.cc	(revision 1728)
@@ -69,5 +69,5 @@
         this->bIsVector_ = false;
 
-        this->defvalueString_ = this->value_.toString();
+        this->defvalueString_ = this->value_.getString();
         this->update();
     }
Index: code/branches/core3/src/core/TclBind.cc
===================================================================
--- code/branches/core3/src/core/TclBind.cc	(revision 1727)
+++ code/branches/core3/src/core/TclBind.cc	(revision 1728)
@@ -115,5 +115,5 @@
 
         if (CommandExecutor::getLastEvaluation().hasReturnvalue())
-            return CommandExecutor::getLastEvaluation().getReturnvalue().toString();
+            return CommandExecutor::getLastEvaluation().getReturnvalue().getString();
 
         return "";
Index: code/branches/core3/src/core/TclThreadManager.cc
===================================================================
--- code/branches/core3/src/core/TclThreadManager.cc	(revision 1727)
+++ code/branches/core3/src/core/TclThreadManager.cc	(revision 1728)
@@ -519,5 +519,5 @@
 
                 if (CommandExecutor::getLastEvaluation().hasReturnvalue())
-                    output = CommandExecutor::getLastEvaluation().getReturnvalue().toString();
+                    output = CommandExecutor::getLastEvaluation().getReturnvalue().getString();
             }
 
Index: code/branches/core3/src/util/MultiType.h
===================================================================
--- code/branches/core3/src/util/MultiType.h	(revision 1727)
+++ code/branches/core3/src/util/MultiType.h	(revision 1728)
@@ -214,4 +214,9 @@
         inline void                       setType(MT_Type type)           { this->reset(); this->convert(type); }
 
+        inline MT_Type                    getType()                 const { return (this->value_) ? this->value_->type_ : MT_null; }
+        inline bool                       isType(MT_Type type)      const { return (this->value_) ? (this->value_->type_ == type) : (type == MT_null); }
+        template <typename T> inline bool isType()                  const { return false; }
+        std::string                       getTypename()             const;
+
         operator char()                  const;
         operator unsigned char()         const;
@@ -263,10 +268,28 @@
         inline void getValue(orxonox::Degree*      value) const { if (this->value_) { (*value) = this->value_->operator orxonox::Degree();      } }
 
-        inline MT_Type                    getType()            const { return (this->value_) ? this->value_->type_ : MT_null; }
-        inline bool                       isType(MT_Type type) const { return (this->value_) ? (this->value_->type_ == type) : (type == MT_null); }
-        template <typename T> inline bool isType()             const { return false; }
-        std::string                       getTypename()        const;
-
-        inline std::string toString() const { return this->operator std::string(); }
+        inline char                     getChar()             const { return this->operator char();                 }
+        inline unsigned char            getUnsignedChar()     const { return this->operator unsigned char();        }
+        inline short                    getShort()            const { return this->operator short();                }
+        inline unsigned short           getUnsignedShort()    const { return this->operator unsigned short();       }
+        inline int                      getInt()              const { return this->operator int();                  }
+        inline unsigned int             getUnsignedInt()      const { return this->operator unsigned int();         }
+        inline long                     getLong()             const { return this->operator long();                 }
+        inline unsigned long            getUnsignedLong()     const { return this->operator unsigned long();        }
+        inline long long                getLongLong()         const { return this->operator long long();            }
+        inline unsigned long long       getUnsignedLongLong() const { return this->operator unsigned long long();   }
+        inline float                    getFloat()            const { return this->operator float();                }
+        inline double                   getDouble()           const { return this->operator double();               }
+        inline long double              getLongDouble()       const { return this->operator long double();          }
+        inline bool                     getBool()             const { return this->operator bool();                 }
+        inline void*                    getVoid()             const { return this->operator void*();                }
+        inline std::string              getString()           const { return this->operator std::string();          }
+        inline orxonox::Vector2         getVector2()          const { return this->operator orxonox::Vector2();     }
+        inline orxonox::Vector3         getVector3()          const { return this->operator orxonox::Vector3();     }
+        inline orxonox::Vector4         getVector4()          const { return this->operator orxonox::Vector4();     }
+        inline orxonox::ColourValue     getColourValue()      const { return this->operator orxonox::ColourValue(); }
+        inline orxonox::Quaternion      getQuaternion()       const { return this->operator orxonox::Quaternion();  }
+        inline orxonox::Radian          getRadian()           const { return this->operator orxonox::Radian();      }
+        inline orxonox::Degree          getDegree()           const { return this->operator orxonox::Degree();      }
+        template <typename T> inline T* getPointer()          const { return ((T*)this->getVoid());                 }
 
     private: