Index: /code/branches/network/src/network/Client.h
===================================================================
--- /code/branches/network/src/network/Client.h	(revision 1731)
+++ /code/branches/network/src/network/Client.h	(revision 1732)
@@ -80,5 +80,5 @@
     unsigned int shipID(){return shipID_;}
     int playerID(){return clientID_;}
-    static void setShipID( unsigned int shipID){ dynamic_cast<Client *>(instance_)->shipID_=shipID; }
+    //static void setShipID( unsigned int shipID){ dynamic_cast<Client *>(instance_)->shipID_=shipID; }
     static void setClientID( unsigned int clientID){ dynamic_cast<Client *>(instance_)->clientID_=clientID; }
     
Index: /code/branches/network/src/network/Host.cc
===================================================================
--- /code/branches/network/src/network/Host.cc	(revision 1731)
+++ /code/branches/network/src/network/Host.cc	(revision 1732)
@@ -48,9 +48,9 @@
 }
 
-unsigned int Host::getShipID(){ 
-  if(!instance_)
-    return 0;
-  return instance_->shipID();
-}
+// unsigned int Host::getShipID(){ 
+//   if(!instance_)
+//     assert(0);
+//   return instance_->shipID();
+// }
 
 }//namespace network
Index: /code/branches/network/src/network/Host.h
===================================================================
--- /code/branches/network/src/network/Host.h	(revision 1731)
+++ /code/branches/network/src/network/Host.h	(revision 1732)
@@ -61,5 +61,5 @@
 //     static bool receiveChat(packet::Chat *message, unsigned int clientID);
     static int getPlayerID();
-    static unsigned int getShipID();
+    static unsigned int getShipID(){return instance_->shipID_;}
     static void setClientID(unsigned int id){ instance_->clientID_ = id; }
     static void setShipID(unsigned int id){ instance_->shipID_ = id; }
Index: /code/branches/network/src/network/packet/Welcome.cc
===================================================================
--- /code/branches/network/src/network/packet/Welcome.cc	(revision 1731)
+++ /code/branches/network/src/network/packet/Welcome.cc	(revision 1732)
@@ -32,4 +32,5 @@
 #include "Welcome.h"
 #include "network/Host.h"
+#include "core/CoreIncludes.h"
 #include <assert.h>
 
@@ -77,4 +78,5 @@
   Host::setClientID(clientID);
   Host::setShipID(shipID);
+  COUT(3) << "Welcome set clientId: " << clientID << " shipID: " << shipID << std::endl;
   delete this;
   return true;
Index: /code/branches/network/src/orxonox/objects/Ambient.h
===================================================================
--- /code/branches/network/src/orxonox/objects/Ambient.h	(revision 1731)
+++ /code/branches/network/src/orxonox/objects/Ambient.h	(revision 1732)
@@ -38,5 +38,5 @@
 namespace orxonox
 {
-    class _OrxonoxExport Ambient : public BaseObject, network::Synchronisable
+    class _OrxonoxExport Ambient : public BaseObject, public network::Synchronisable
     {
         public:
Index: /code/branches/network/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 1731)
+++ /code/branches/network/src/orxonox/objects/SpaceShip.cc	(revision 1732)
@@ -76,5 +76,5 @@
           return *it;
       }
-      return NULL;
+      return 0;
     }
 
@@ -158,4 +158,6 @@
     bool SpaceShip::create(){
       if(!myShip_){
+        if(network::Host::running())
+          COUT(3) << "this id: " << this->objectID << " myShipID: " << network::Host::getShipID() << std::endl;
         if(network::Host::running() && objectID == network::Host::getShipID())
           myShip_=true;
@@ -163,8 +165,6 @@
           HUD::getSingleton().addRadarObject(this, this->getProjectileColour());
       }
-      if(Model::create())
-        this->init();
-      else
-        return false;
+      assert(Model::create());
+      this->init();
       return true;
     }
@@ -287,5 +287,5 @@
 
     void SpaceShip::getFocus(){
-      COUT(4) << "requesting focus" << std::endl;
+      COUT(3) << "requesting focus" << std::endl;
       //if(!network::Host::running() || network::Host::getShipID()==objectID)
       if(myShip_)
@@ -301,5 +301,5 @@
 //       COUT(4) << "begin camera creation" << std::endl;
       this->camNode_ = this->getNode()->createChildSceneNode(camName_);
-      COUT(4) << "position: (this)" << this->getNode()->getPosition() << std::endl;
+      COUT(3) << "position: (this)" << this->getNode()->getPosition() << std::endl;
       this->camNode_->setPosition(Vector3(-25,0,5));
 //      Quaternion q1 = Quaternion(Radian(Degree(90)),Vector3(0,-1,0));