Index: code/branches/core3/src/core/BaseObject.h
===================================================================
--- code/branches/core3/src/core/BaseObject.h	(revision 1728)
+++ code/branches/core3/src/core/BaseObject.h	(revision 1736)
@@ -103,7 +103,7 @@
     };
 
-    SUPER_FUNCTION(1, BaseObject, XMLPort, false);
-    SUPER_FUNCTION(3, BaseObject, changedActivity, false);
-    SUPER_FUNCTION(4, BaseObject, changedVisibility, false);
+    SUPER_FUNCTION(0, BaseObject, XMLPort, false);
+    SUPER_FUNCTION(2, BaseObject, changedActivity, false);
+    SUPER_FUNCTION(3, BaseObject, changedVisibility, false);
 }
 
Index: code/branches/core3/src/core/Namespace.cc
===================================================================
--- code/branches/core3/src/core/Namespace.cc	(revision 1728)
+++ code/branches/core3/src/core/Namespace.cc	(revision 1736)
@@ -60,5 +60,4 @@
     void Namespace::XMLPort(Element& xmlelement, XMLPort::Mode mode)
     {
-//        BaseObject::XMLPort(xmlelement, mode);
         SUPER(Namespace, XMLPort, xmlelement, mode);
 
Index: code/branches/core3/src/core/Super.h
===================================================================
--- code/branches/core3/src/core/Super.h	(revision 1728)
+++ code/branches/core3/src/core/Super.h	(revision 1736)
@@ -105,5 +105,5 @@
                     if (!((ClassIdentifier<T>*)(*it))->superFunctionCaller_##functionname##_) \
                     { \
-                        COUT(0) << "Added SuperFunctionCaller for " << #functionname << ": " << ClassIdentifier<T>::getIdentifier()->getName() << " <- " << ((ClassIdentifier<T>*)(*it))->getName() << std::endl; \
+                        COUT(5) << "Added SuperFunctionCaller for " << #functionname << ": " << ClassIdentifier<T>::getIdentifier()->getName() << " <- " << ((ClassIdentifier<T>*)(*it))->getName() << std::endl; \
                         ((ClassIdentifier<T>*)(*it))->superFunctionCaller_##functionname##_ = new SuperFunctionClassCaller_##functionname <T>; \
                     } \
@@ -218,7 +218,4 @@
 
     // (1/3) --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <--
-    #define SUPER_testfunction(classname, functionname, ...) \
-        SUPER_NOARGS(classname, functionname)
-
     #define SUPER_XMLPort(classname, functionname, ...) \
         SUPER_ARGS(classname, functionname, __VA_ARGS__)
@@ -421,21 +418,17 @@
 
         // (2/3) --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <--
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(0, testfunction, false)
+        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(0, XMLPort, true, Element& xmlelement, XMLPort::Mode mode)
+            (xmlelement, mode)
+        SUPER_FUNCTION_GLOBAL_DECLARATION_PART2;
+
+        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(1, tick, true, float dt)
+            (dt)
+        SUPER_FUNCTION_GLOBAL_DECLARATION_PART2;
+
+        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(2, changedActivity, false)
             ()
         SUPER_FUNCTION_GLOBAL_DECLARATION_PART2;
 
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(1, XMLPort, true, Element& xmlelement, XMLPort::Mode mode)
-            (xmlelement, mode)
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART2;
-
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(2, tick, true, float dt)
-            (dt)
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART2;
-
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(3, changedActivity, false)
-            ()
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART2;
-
-        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(4, changedVisibility, false)
+        SUPER_FUNCTION_GLOBAL_DECLARATION_PART1(3, changedVisibility, false)
             ()
         SUPER_FUNCTION_GLOBAL_DECLARATION_PART2;
@@ -482,5 +475,4 @@
 
     // (3/3) --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <-- --> HERE <--
-    SUPER_INTRUSIVE_DECLARATION(testfunction);
     SUPER_INTRUSIVE_DECLARATION(XMLPort);
     SUPER_INTRUSIVE_DECLARATION(tick);